<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Vue Router</title>
</head>
<body>
    <div id="app">
        <h1>Belajar Vue Router</h1>
        <form @submit.prevent="submitForm()">
            <label>Login :</label>
            <input class="input is-primary" type="text" name="name" ref="name" v-model="login">

        </form>
        <p v-if="login"> anda telah login sebagai {{ login }}</p>
        <p v-else> anda belum login</p>
    
        <router-link to="/">Halaman Umum</router-link>
        <router-link to="/halaman2">Halaman Member</router-link>
        <router-link to="/halaman3">Halaman Admin</router-link>
        <hr>
    
        <router-view></router-view>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://unpkg.com/vue-router/dist/vue-router.js"></script>
    <script type="module">
        let login
        const halaman1 = {
            template: `<div>Ini Halaman Umum</div>`, 
            props: ['login']
            }
        const halaman2 = {
            template: `<div>Ini Halaman Member</div>`, 
            props: ['login']
            }
        const halaman3 = {
            template: `<div>Ini Halaman Admin</div>`, 
            props: ['login']
            }

        const routes = [
            {
                path: '/', 
                component: halaman1, 
                name: 'home', 
                alias: '/home'
            },
            {
                path: '/halaman2', 
                component: halaman2, 
                name: 'member', 
                meta: {login: true}, 
                props: {default: login, sidebar: false}
            },
            {
                path: '/halaman3', 
                component: halaman3, 
                meta: {login: true, role: 'admin'}
            },
            {
                path: '*', 
                redirect: '/'
            }
        ]

        Vue.use(VueRouter)
        const router = new VueRouter({
            mode : 'history',
            routes
        })

        router.beforeEach((to, from, next) => {
            let auth
            if (to.meta.login) {
            if (to.meta.role === 'admin')
                if (vm && vm.login && vm.login === 'admin') {
                    next(true)
                } else {
                alert('hanya admin yang dapat mengakses halaman ini')
                next(false)
                }
            else if (vm && vm.login) {
                next(true)
            } else {
                next(false)
                alert('anda harus login dulu')
            }
            } else {
            next()
            }
        })

        let vm = new Vue({
            el: '#app',
            router,
            data: {
            login
            }
        })
    </script>
</body>
</html>